// Exec.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <vector>//   
#include "ExecMenuItem.h"//   
#include "APPHelper.h"//  Aml Pages
#include <shellapi.h>//"    "
#include "SysImageList.h"//      HIMAGELIST
#include <commdlg.h>//  Windows
#include <winreg.h>//   Windows
#include <string.h>//  (  \ \ (-))

HMODULE m_hModule;//HMODULE DLL- 

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  reason, 
                       LPVOID lpReserved
					 )
{
	if (DLL_PROCESS_ATTACH==reason)
		m_hModule=(HMODULE)hModule;// HMODULE DLL- 
    return TRUE;
}

//   
typedef std::vector<CExecMenuItem> VECTOR;

//      
//  "Software\\G&G Software\\Aml Pages\\Plugins\\MY_PLUGIN_NAME"
#ifndef _DEBUG
#define MY_KEY "Software\\G&G Software\\Aml Pages\\Plugins\\Exec Sample" 
#else
#define MY_KEY "Software\\G&G Software\\Aml Pages\\Plugins\\Exec Sample Debug"
#endif

//          
void GetRegItemName(LPTSTR lpszName, DWORD dwIndex)
{
	ASSERT(lpszName);
	sprintf(lpszName,"Item%d",dwIndex);
}

//  ,   -  
#define COUNT "Count"

//    
bool ReadData(VECTOR& v)
{
	HKEY hkey=NULL;
	//  
	if (ERROR_SUCCESS!=RegOpenKeyEx(HKEY_CURRENT_USER,MY_KEY,0,KEY_QUERY_VALUE,&hkey))
		return false;

	// -  
	DWORD dwSize=0;
	DWORD dwType=REG_DWORD;
	DWORD cbSize=sizeof(DWORD);
	if (ERROR_SUCCESS==RegQueryValueEx(hkey,COUNT,NULL,&dwType,(LPBYTE)&dwSize,&cbSize)) {
		// 
		v.clear();
		//   
		v.reserve(dwSize+1);

		//   
		for (DWORD i=0;i<dwSize;i++) {
			//     
			char szName[8]={0};
			GetRegItemName(szName,i);
			char szPath[MAX_PATH+1]={0};
			cbSize=sizeof(szPath)*sizeof(char);
			// 
			if (ERROR_SUCCESS==RegQueryValueEx(hkey,szName,0,&dwType,(LPBYTE)szPath,&cbSize)) {
				CExecMenuItem mi(szPath);//   
				v.push_back(mi);
			}
		}
	}

	//  
	RegCloseKey(hkey);
	return true;
}

//    
bool SaveData(const VECTOR& v)
{
	HKEY hkey=NULL;
	//   
	if (ERROR_SUCCESS!=RegCreateKeyEx(HKEY_CURRENT_USER,MY_KEY,NULL,NULL,0,KEY_ALL_ACCESS,NULL,&hkey,NULL))
		return false;

	//    
	DWORD dwSize=v.size();
	::RegSetValueEx(hkey,COUNT,0,REG_DWORD,(CONST BYTE*)&dwSize,sizeof(DWORD));
	//   
	for (VECTOR::const_iterator it=v.begin();it!=v.end();it++) {
		//    
		char szName[8];
		GetRegItemName(szName,it-v.begin());

		// 
		RegSetValueEx(hkey,szName,0,REG_SZ,(CONST BYTE*)it->m_szPath,strlen(it->m_szPath)*sizeof(char));
	}

	// 
	RegCloseKey(hkey);
	return true;
}

//     
VECTOR& GetData()
{
	// 
	static VECTOR v;
	
	if (v.empty()) {//  
		ReadData(v);//    
		if (v.empty()) {//        ?
			//      Windows (   -    !?!)
			CExecMenuItem mi;
			
			//   
			char szWinPath[MAX_PATH+1]={0};
			
			GetWindowsDirectory(szWinPath,MAX_PATH);
			
			strncpy(mi.m_szPath,szWinPath,sizeof(mi.m_szPath));
			strncat(mi.m_szPath,"\\notepad.exe",sizeof(mi.m_szPath)-strlen(mi.m_szPath));
			
			//   
			v.push_back(mi);
		}
	}

	//     
	return v;
}

extern "C"
BOOL __declspec(dllexport) Aml_GetPluginInfo(AML_PLUGIN_INFO* p)
{
	ASSERT(p);
	//   Aml Pages 9.00.1746,
	//   Aml Pages   
	// AP_EXECCOMMAND
	p->nMinRelease=1746;
	//    
	const int nSize=GetData().size();
	//  
	p->nMenuCount=
		nSize//       
		+1//+  
		+1;//+   "Add File"
	//     "Exec Sample"
	strncpy(p->szMenuName,"Exec (Sample)",sizeof(p->szMenuName));
	//  (  !?!)
	return TRUE;
}

extern "C"
BOOL __declspec(dllexport) Aml_GetMenuItemInfo(UINT nIndex, AML_MENU_ITEM_INFO* p)
{
	ASSERT(p);// 
	//        -     
	if ((nIndex>=0) && (nIndex<GetData().size())) {
		//      
		CSysImageList& iml=CSysImageList::GetSysImageList();

		//   
		VECTOR::const_iterator it=GetData().begin()+nIndex;
		ASSERT(it);// !?!?
		//    
		char szName[_MAX_FNAME]={0};
		char  szExt[_MAX_EXT]={0};
		_splitpath(it->m_szPath,NULL,NULL,szName,szExt);
		
		//        
		strncpy(p->szMenuName,szName,sizeof(p->szMenuName));
		strncat(p->szMenuName,szExt,sizeof(p->szMenuName)-strlen(p->szMenuName));

		// LPARAM    ,     
		//    
		p->lParam=nIndex;
		
		// ,   Aml Pages  DLL 
		//    
		strncpy(p->szFunctionName,"ExecMenu",sizeof(p->szFunctionName));

		//    
		HICON hIcon=iml.GetIcon(it->m_szPath);
		if (hIcon) {//      ???
			//  ,
			//..     Aml Pages    HIMAGELIST
			//(Aml Pages     
			//    ,  .  MSDN LoadLibrary+FreeLibrary)
			p->hIcon=CopyIcon(hIcon);
		}

		//    Aml Pages    
		p->nPluginType=APPT_EXECCOMMAND;//    ,     
		//   AML_EXECCOMMAND
		p->dwFlags|=APF_SYSTRAYMENU;
		// 
		return TRUE;
	}
	else if (nIndex==GetData().size()) {
		// nIndex    
		//  
		//(      AML_MENU_ITEM_INFO::szFunctionName
		//Aml Pages    - )
		return TRUE;
	}
	else if (nIndex==GetData().size()+1) {//     -
		//   "Add File"
		strncpy(p->szMenuName,"   ",sizeof(p->szMenuName));// 
		strncpy(p->szFunctionName,"AddFile",sizeof(p->szFunctionName));// DLL         
		p->nPluginType=APPT_EXECCOMMAND;//  
		//
		return TRUE;
	}
	else {
		//     
		ASSERT(FALSE);
		return FALSE;
	}
}

//      (  , 
//   Aml_GetMenuItemInfo
//
//  lParam  AML_PAGECONTENT  
//      Aml_GetMenuItemInfo)
extern "C"
BOOL __declspec(dllexport) ExecMenu(AML_EXECCOMMAND* p)
{
	//     ,
	//  lParam   Aml_GetMenuItemInfo
	//  
	if ((p->lParam<0) || (p->lParam>=GetData().size())) {
		ASSERT(FALSE);//     ,
		return FALSE;//     
	}

	//      
	VECTOR::const_iterator it=GetData().begin()+p->lParam;

	//    it->m_szPath  
	char szDrive[_MAX_DRIVE]={0};
	char  szTmp[_MAX_DIR]={0};

	_splitpath(it->m_szPath,szDrive,szTmp,NULL,NULL);

	char szDir[MAX_PATH+1]={0};
	strncpy(szDir,szDrive,sizeof(szDir));
	strncat(szDir,szTmp,sizeof(szDir)-strlen(szDir));
	
	// ""  
	const int n=(int)::ShellExecute(APPHelper::GetMainHWND()//HWND   Aml Pages
		,"open"
		,it->m_szPath//  
		,NULL
		,szDir//     
		,SW_SHOW//   "  "
		);

	ASSERT(n>31);
	return (n>31);//  ??? ( .  MSDN)
}

// DLL-,      "Add File"
extern "C" 
BOOL __declspec(dllexport) AddFile(AML_EXECCOMMAND* /*p*/)//   
{
	//    
	OPENFILENAME ofn={0};
	ofn.lStructSize=sizeof(ofn);
	ofn.hInstance=m_hModule;
	ofn.hwndOwner=APPHelper::GetMainHWND();//  =  Aml Pages
	ofn.lpstrFilter="  (*.exe)\0*.exe\0 Aml Pages (*,apd, *.adl)\0*.apd;*.adl\0   (*.adl)\0*.adl\0  (*.*)\0*.*\0\0";
	ofn.Flags=OFN_EXPLORER|OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY;
	char szFile[MAX_PATH+1]={0};
	ofn.lpstrFile=szFile;
	ofn.nMaxFile=MAX_PATH;
	ofn.lpstrTitle="    'Exec Sample'";

	//   
	//( "" (     )
	// , comdlg32.dll  
	//       Aml Pages)
	//      
	const HMODULE hLib=LoadLibrary("comdlg32.dll");
	ASSERT(hLib);//   !?!? !!!

	//   
	if (GetOpenFileName(&ofn)) {//     ?
		//          ?
		int nCmp=1;
		for (VECTOR::const_iterator it=GetData().begin();it!=GetData().end();it++) {
			nCmp=stricmp(it->m_szPath,ofn.lpstrFile);
			if (!nCmp) break;//   
		}

		if (nCmp) {//   
			//     ""  
			CExecMenuItem mi(ofn.lpstrFile);
			GetData().push_back(mi);
			//    
			SaveData(GetData());
			// Aml Pages  
			//   m_hModule ( )
			//     (  )
			APPHelper::ReReadPluginsInfo(m_hModule);
		}
		else {//   
			// 
			char sz[MAX_PATH*2]={0};
			sprintf(sz," \n%s\n     'Exec Sample'",ofn.lpstrFile);
			MessageBox(APPHelper::GetMainHWND(),sz,"Exec Sample",MB_ICONEXCLAMATION);
		}
	}

	//   ""...
	//DWORD dw=CommDlgExtendedError();

	//     
	if (hLib)
		FreeLibrary(hLib);

	//   (..     
	//   )
	return TRUE;	
}
